<template>
  <v-toolbar
    density="compact"
    floating
    width="100%"
    title="Usuario del Portal del Estudiante"
  />
  <v-form class="pa-2">
    <v-text-field v-model="usuario" label="Usuario" :rules="usuarioRules" />
    <v-text-field
      v-model="contra"
      label="Contraseña"
      :rules="contraRules"
      type="password"
    />
    <v-btn v-text="'Login'" @click="login(usuario, contra)" />
  </v-form>
</template>

<script setup lang="ts">
import { ref } from "vue";
import { backendCollector } from "../data/collectors/backendCollector";
import { router } from "../router";

function validarString(mensajeError: string) {
  return (value: string) => {
    try {
      String(value);
      return value ? true : mensajeError;
    } catch {
      return mensajeError;
    }
  };
}

const usuario = ref("");
const usuarioRules = ref([validarString("usuario invalido")]);

const contra = ref("");
const contraRules = ref([validarString("contraseña invalida")]);

function formInvalido() {
  if (
    usuarioRules.value[0](usuario.value) != true ||
    contraRules.value[0](contra.value) != true
  ) {
    return true;
  }
  return false;
}

const loggedIn = await backendCollector.login();
if (loggedIn.success) {
  console.log("successfully logged in")
  router.push("/")
}

async function login(username: string, password: string) {
  if (formInvalido()) {
    alert("Ingrese Datos Correctamente");
  } else {
    try {
      let fetched = await backendCollector.server.postLogin(username, password);
      if (!fetched.success) {
        console.log(fetched);
        alert("Login Invalido");
      } else {
        saveUsernameAndToken({
          username: username,
          token: fetched.data!.token,
        });
      }
    } catch (e) {
      console.log(`error desconocido: ${e}`);
    }
  }
}

function saveUsernameAndToken(message: { username: string; token: string }) {
  backendCollector.server.username = message.username;
  backendCollector.server.token = message.token;
  backendCollector.client.saveToken(message);
  router.push("/");
}
</script>
